diff --git a/gcc/convert.c b/gcc/convert.c
index 91c1da2..e669849 100644
--- a/gcc/convert.c
+++ b/gcc/convert.c
@@ -100,7 +100,7 @@ convert_to_real (tree type, tree expr)
   /* Disable until we figure out how to decide whether the functions are
      present in runtime.  */
   /* Convert (float)sqrt((double)x) where x is float into sqrtf(x) */
-  if (optimize
+  if (GCC_OPTION (optimize)
       && (TYPE_MODE (type) == TYPE_MODE (double_type_node)
           || TYPE_MODE (type) == TYPE_MODE (float_type_node)))
     {
@@ -124,7 +124,7 @@ convert_to_real (tree type, tree expr)
 	    /* The above functions may set errno differently with float
 	       input or output so this transformation is not safe with
 	       -fmath-errno.  */
-	    if (flag_errno_math)
+	    if (GCC_OPTION (flag_errno_math))
 	      break;
 	  CASE_MATHFN (ACOS)
 	  CASE_MATHFN (ACOSH)
@@ -144,7 +144,7 @@ convert_to_real (tree type, tree expr)
  	  CASE_MATHFN (TAN)
  	  CASE_MATHFN (TANH)
 	    /* The above functions are not safe to do this conversion.  */
-	    if (!flag_unsafe_math_optimizations)
+	    if (!GCC_OPTION (flag_unsafe_math_optimizations))
 	      break;
 	  CASE_MATHFN (SQRT)
 	  CASE_MATHFN (FABS)
@@ -174,7 +174,7 @@ convert_to_real (tree type, tree expr)
                  floating-point-square-root
 		 */
 	      if ((fcode == BUILT_IN_SQRT || fcode == BUILT_IN_SQRTL)
-		  && !flag_unsafe_math_optimizations)
+		  && !GCC_OPTION (flag_unsafe_math_optimizations))
 		{
 		  /* The following conversion is unsafe even the precision condition
 		     below is satisfied:
@@ -212,7 +212,7 @@ convert_to_real (tree type, tree expr)
 	  break;
 	}
     }
-  if (optimize
+  if (GCC_OPTION (optimize)
       && (((fcode == BUILT_IN_FLOORL
 	   || fcode == BUILT_IN_CEILL
 	   || fcode == BUILT_IN_ROUNDL
@@ -252,7 +252,7 @@ convert_to_real (tree type, tree expr)
 	   round-to-nearest rounding mode when the inner type is float.  */
 	case ABS_EXPR:
 	case NEGATE_EXPR:
-	  if (!flag_rounding_math
+	  if (!GCC_OPTION (flag_rounding_math)
 	      && FLOAT_TYPE_P (itype)
 	      && TYPE_PRECISION (type) < TYPE_PRECISION (itype))
 	    return build1 (TREE_CODE (expr), type,
@@ -326,7 +326,7 @@ convert_to_real (tree type, tree expr)
 		     values representable in the TYPE to be within the
 		     range of normal values of ITYPE.  */
 		  if (TYPE_PRECISION (newtype) < TYPE_PRECISION (itype)
-		      && (flag_unsafe_math_optimizations
+		      && (GCC_OPTION (flag_unsafe_math_optimizations)
 			  || (TYPE_PRECISION (newtype) == TYPE_PRECISION (type)
 			      && real_can_shorten_arithmetic (TYPE_MODE (itype),
 							      TYPE_MODE (type))
@@ -350,7 +350,7 @@ convert_to_real (tree type, tree expr)
     case REAL_TYPE:
       /* Ignore the conversion if we don't need to store intermediate
 	 results and neither type is a decimal float.  */
-      return build1 ((flag_float_store
+      return build1 ((GCC_OPTION (flag_float_store)
 		     || DECIMAL_FLOAT_TYPE_P (type)
 		     || DECIMAL_FLOAT_TYPE_P (itype))
 		     ? CONVERT_EXPR : NOP_EXPR, type, expr);
@@ -408,8 +408,8 @@ convert_to_integer (tree type, tree expr)
      between converting from double->char vs double->long->char.
      We're in "undefined" territory but we prefer to be conservative,
      so only proceed in "unsafe" math mode.  */
-  if (optimize
-      && (flag_unsafe_math_optimizations
+  if (GCC_OPTION (optimize)
+      && (GCC_OPTION (flag_unsafe_math_optimizations)
 	  || (long_integer_type_node
 	      && outprec >= TYPE_PRECISION (long_integer_type_node))))
     {
@@ -470,7 +470,7 @@ convert_to_integer (tree type, tree expr)
 
 	CASE_FLT_FN (BUILT_IN_NEARBYINT):
 	  /* Only convert nearbyint* if we can ignore math exceptions.  */
-	  if (flag_trapping_math)
+	  if (GCC_OPTION (flag_trapping_math))
 	    break;
 	  /* ... Fall through ...  */
 	CASE_FLT_FN (BUILT_IN_RINT):
@@ -504,9 +504,9 @@ convert_to_integer (tree type, tree expr)
     }
 
   /* Convert (int)logb(d) -> ilogb(d).  */
-  if (optimize
-      && flag_unsafe_math_optimizations
-      && !flag_trapping_math && !flag_errno_math && flag_finite_math_only
+  if (GCC_OPTION (optimize)
+      && GCC_OPTION (flag_unsafe_math_optimizations)
+      && !GCC_OPTION (flag_trapping_math) && !GCC_OPTION (flag_errno_math) && GCC_OPTION (flag_finite_math_only)
       && integer_type_node
       && (outprec > TYPE_PRECISION (integer_type_node)
 	  || (outprec == TYPE_PRECISION (integer_type_node)
diff --git a/gcc/coverage.c b/gcc/coverage.c
index 8b62403..2832fb2 100644
--- a/gcc/coverage.c
+++ b/gcc/coverage.c
@@ -348,7 +348,7 @@ get_coverage_counts (unsigned counter, unsigned expected,
 
       if (!warned++ && dump_enabled_p ())
 	dump_printf_loc (MSG_OPTIMIZED_LOCATIONS, input_location,
-                         (flag_guess_branch_prob
+                         (GCC_OPTION (flag_guess_branch_prob)
                           ? "file %s not found, execution counts estimated\n"
                           : "file %s not found, execution counts assumed to "
                             "be zero\n"),
@@ -389,10 +389,10 @@ get_coverage_counts (unsigned counter, unsigned expected,
 	      dump_printf_loc (MSG_OPTIMIZED_LOCATIONS, input_location,
                                "coverage mismatch ignored\n");
 	      dump_printf (MSG_OPTIMIZED_LOCATIONS,
-                           flag_guess_branch_prob
+                           GCC_OPTION (flag_guess_branch_prob)
                            ? G_("execution counts estimated\n")
                            : G_("execution counts assumed to be zero\n"));
-	      if (!flag_guess_branch_prob)
+	      if (!GCC_OPTION (flag_guess_branch_prob))
 		dump_printf (MSG_OPTIMIZED_LOCATIONS,
                              "this can result in poorly optimized code\n");
 	    }
@@ -566,7 +566,7 @@ coverage_compute_profile_id (struct cgraph_node *n)
     chksum = coverage_checksum_string
       (chksum, first_global_object_name);
   chksum = coverage_checksum_string
-    (chksum, aux_base_name);
+    (chksum, GCC_OPTION (aux_base_name));
 
   /* Non-negative integers are hopefully small enough to fit in all targets.  */
   return chksum & 0x7fffffff;
@@ -1143,19 +1143,19 @@ coverage_init (const char *filename)
     g->get_passes ()->get_pass_profile ()->static_pass_number;
   g->get_dumps ()->dump_start (profile_pass_num, NULL);
 
-  if (!profile_data_prefix && !IS_ABSOLUTE_PATH (filename))
-    profile_data_prefix = getpwd ();
+  if (!GCC_OPTION (profile_data_prefix) && !IS_ABSOLUTE_PATH (filename))
+    GCC_OPTION (profile_data_prefix) = getpwd ();
 
-  if (profile_data_prefix)
-    prefix_len = strlen (profile_data_prefix);
+  if (GCC_OPTION (profile_data_prefix))
+    prefix_len = strlen (GCC_OPTION (profile_data_prefix));
 
   /* Name of da file.  */
   da_file_name = XNEWVEC (char, len + strlen (GCOV_DATA_SUFFIX)
 			  + prefix_len + 2);
 
-  if (profile_data_prefix)
+  if (GCC_OPTION (profile_data_prefix))
     {
-      memcpy (da_file_name, profile_data_prefix, prefix_len);
+      memcpy (da_file_name, GCC_OPTION (profile_data_prefix), prefix_len);
       da_file_name[prefix_len++] = '/';
     }
   memcpy (da_file_name + prefix_len, filename, len);
@@ -1163,11 +1163,11 @@ coverage_init (const char *filename)
 
   bbg_file_stamp = local_tick;
   
-  if (flag_branch_probabilities)
+  if (GCC_OPTION (flag_branch_probabilities))
     read_counts_file ();
 
   /* Name of bbg file.  */
-  if (flag_test_coverage && !flag_compare_debug)
+  if (GCC_OPTION (flag_test_coverage) && !GCC_OPTION (flag_compare_debug))
     {
       bbg_file_name = XNEWVEC (char, len + strlen (GCOV_NOTE_SUFFIX) + 1);
       memcpy (bbg_file_name, filename, len);
@@ -1198,7 +1198,7 @@ coverage_finish (void)
   if (bbg_file_name && gcov_close ())
     unlink (bbg_file_name);
 
-  if (!flag_branch_probabilities && flag_test_coverage
+  if (!GCC_OPTION (flag_branch_probabilities) && GCC_OPTION (flag_test_coverage)
       && (!local_tick || local_tick == (unsigned)-1))
     /* Only remove the da file, if we're emitting coverage code and
        cannot uniquely stamp it.  If we can stamp it, libgcov will DTRT.  */
diff --git a/gcc/cp/call.c b/gcc/cp/call.c
index 877f6d9..76defaa 100644
--- a/gcc/cp/call.c
+++ b/gcc/cp/call.c
@@ -3644,7 +3644,7 @@ build_user_type_conversion_1 (tree totype, tree expr, int flags,
 	}
     }
 
-  candidates = splice_viable (candidates, pedantic, &any_viable_p);
+  candidates = splice_viable (candidates, GCC_OPTION (pedantic), &any_viable_p);
   if (!any_viable_p)
     {
       if (args)
@@ -3870,7 +3870,7 @@ perform_overload_resolution (tree fn,
 		  LOOKUP_NORMAL,
 		  candidates, complain);
 
-  *candidates = splice_viable (*candidates, pedantic, any_viable_p);
+  *candidates = splice_viable (*candidates, GCC_OPTION (pedantic), any_viable_p);
   if (*any_viable_p)
     cand = tourney (*candidates, complain);
   else
@@ -3922,7 +3922,7 @@ build_new_function_call (tree fn, vec<tree, va_gc> **args, bool koenig_p,
 	return error_mark_node;
     }
 
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     tm_malloc_replacement (fn);
 
   /* If this function was found without using argument dependent
@@ -4008,7 +4008,7 @@ build_operator_new_call (tree fnname, vec<tree, va_gc> **args,
   if (size_check != NULL_TREE)
     {
       tree errval = TYPE_MAX_VALUE (sizetype);
-      if (cxx_dialect >= cxx11 && flag_exceptions)
+      if (cxx_dialect >= cxx11 && GCC_OPTION (flag_exceptions))
 	errval = throw_bad_array_new_length ();
       *size = fold_build3 (COND_EXPR, sizetype, size_check,
 			   original_size, errval);
@@ -4181,7 +4181,7 @@ build_op_call_1 (tree obj, vec<tree, va_gc> **args, tsubst_flags_t complain)
 	  }
     }
 
-  candidates = splice_viable (candidates, pedantic, &any_viable_p);
+  candidates = splice_viable (candidates, GCC_OPTION (pedantic), &any_viable_p);
   if (!any_viable_p)
     {
       if (complain & tf_error)
@@ -4274,7 +4274,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
   switch (code)
     {
     case COND_EXPR:
-      if (flag_diagnostics_show_caret)
+      if (GCC_OPTION (flag_diagnostics_show_caret))
 	error_at (loc, op_error_string (G_("ternary %<operator?:%>"),
 					3, match),
 		  TREE_TYPE (arg1), TREE_TYPE (arg2), TREE_TYPE (arg3));
@@ -4287,7 +4287,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
 
     case POSTINCREMENT_EXPR:
     case POSTDECREMENT_EXPR:
-      if (flag_diagnostics_show_caret)
+      if (GCC_OPTION (flag_diagnostics_show_caret))
 	error_at (loc, op_error_string (G_("%<operator%s%>"), 1, match),
 		  opname, TREE_TYPE (arg1));
       else
@@ -4297,7 +4297,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
       break;
 
     case ARRAY_REF:
-      if (flag_diagnostics_show_caret)
+      if (GCC_OPTION (flag_diagnostics_show_caret))
 	error_at (loc, op_error_string (G_("%<operator[]%>"), 2, match),
 		  TREE_TYPE (arg1), TREE_TYPE (arg2));
       else
@@ -4308,7 +4308,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
 
     case REALPART_EXPR:
     case IMAGPART_EXPR:
-      if (flag_diagnostics_show_caret)
+      if (GCC_OPTION (flag_diagnostics_show_caret))
 	error_at (loc, op_error_string (G_("%qs"), 1, match),
 		  opname, TREE_TYPE (arg1));
       else
@@ -4318,7 +4318,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
 
     default:
       if (arg2)
-	if (flag_diagnostics_show_caret)
+	if (GCC_OPTION (flag_diagnostics_show_caret))
 	  error_at (loc, op_error_string (G_("%<operator%s%>"), 2, match),
 		    opname, TREE_TYPE (arg1), TREE_TYPE (arg2));
 	else
@@ -4327,7 +4327,7 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
 		    opname, arg1, opname, arg2,
 		    TREE_TYPE (arg1), TREE_TYPE (arg2));
       else
-	if (flag_diagnostics_show_caret)
+	if (GCC_OPTION (flag_diagnostics_show_caret))
 	  error_at (loc, op_error_string (G_("%<operator%s%>"), 1, match),
 		    opname, TREE_TYPE (arg1));
 	else
@@ -4794,7 +4794,7 @@ build_conditional_expr_1 (location_t loc, tree arg1, tree arg2, tree arg3,
 
 	 If the overload resolution fails, the program is
 	 ill-formed.  */
-      candidates = splice_viable (candidates, pedantic, &any_viable_p);
+      candidates = splice_viable (candidates, GCC_OPTION (pedantic), &any_viable_p);
       if (!any_viable_p)
 	{
           if (complain & tf_error)
@@ -4892,7 +4892,7 @@ build_conditional_expr_1 (location_t loc, tree arg1, tree arg2, tree arg3,
 			"conditional expression: %qT vs %qT",
 			arg2_type, arg3_type);
         }
-      else if (extra_warnings
+      else if (GCC_OPTION (extra_warnings)
 	       && ((TREE_CODE (arg2_type) == ENUMERAL_TYPE
 		    && !same_type_p (arg3_type, type_promotes_to (arg2_type)))
 		   || (TREE_CODE (arg3_type) == ENUMERAL_TYPE
@@ -5320,7 +5320,7 @@ build_new_op_1 (location_t loc, enum tree_code code, int flags, tree arg1,
       break;
 
     default:
-      strict_p = pedantic;
+      strict_p = GCC_OPTION (pedantic);
       break;
     }
 
@@ -5342,14 +5342,14 @@ build_new_op_1 (location_t loc, enum tree_code code, int flags, tree arg1,
 	     -fpermissive.  */
 	  else
 	    {
-	      const char *msg = (flag_permissive) 
+	      const char *msg = (GCC_OPTION (flag_permissive)) 
 		? G_("no %<%D(int)%> declared for postfix %qs,"
 		     " trying prefix operator instead")
 		: G_("no %<%D(int)%> declared for postfix %qs");
 	      permerror (loc, msg, fnname, operator_name_info[code].name);
 	    }
 
-	  if (!flag_permissive)
+	  if (!GCC_OPTION (flag_permissive))
 	    return error_mark_node;
 
 	  if (code == POSTINCREMENT_EXPR)
@@ -6358,7 +6358,7 @@ convert_arg_to_ellipsis (tree arg, tsubst_flags_t complain)
       && !DECIMAL_FLOAT_MODE_P (TYPE_MODE (arg_type)))
     {
       if ((complain & tf_warning)
-	  && warn_double_promotion && !c_inhibit_evaluation_warnings)
+	  && GCC_OPTION (warn_double_promotion) && !c_inhibit_evaluation_warnings)
 	warning_at (loc, OPT_Wdouble_promotion,
 		    "implicit conversion from %qT to %qT when passing "
 		    "argument to function",
@@ -6603,7 +6603,7 @@ convert_for_arg_passing (tree type, tree val, tsubst_flags_t complain)
 				   TYPE_SIZE (integer_type_node)))
     val = cp_perform_integral_promotions (val, complain);
   if ((complain & tf_warning)
-      && warn_suggest_attribute_format)
+      && GCC_OPTION (warn_suggest_attribute_format))
     {
       tree rhstype = TREE_TYPE (val);
       const enum tree_code coder = TREE_CODE (rhstype);
@@ -6624,7 +6624,7 @@ convert_for_arg_passing (tree type, tree val, tsubst_flags_t complain)
 bool
 magic_varargs_p (tree fn)
 {
-  if (flag_cilkplus && is_cilkplus_reduce_builtin (fn) != BUILT_IN_NONE)
+  if (GCC_OPTION (flag_cilkplus) && is_cilkplus_reduce_builtin (fn) != BUILT_IN_NONE)
     return true;
 
   if (DECL_BUILT_IN (fn))
@@ -6978,7 +6978,7 @@ build_over_call (struct z_candidate *cand, int flags, tsubst_flags_t complain)
       /* Warn about initializer_list deduction that isn't currently in the
 	 working draft.  */
       if (cxx_dialect > cxx98
-	  && flag_deduce_init_list
+	  && GCC_OPTION (flag_deduce_init_list)
 	  && cand->template_decl
 	  && is_std_init_list (non_reference (type))
 	  && BRACE_ENCLOSED_INITIALIZER_P (arg))
@@ -7048,7 +7048,7 @@ build_over_call (struct z_candidate *cand, int flags, tsubst_flags_t complain)
   /* Avoid actually calling copy constructors and copy assignment operators,
      if possible.  */
 
-  if (! flag_elide_constructors)
+  if (! GCC_OPTION (flag_elide_constructors))
     /* Do things the hard way.  */;
   else if (cand->num_convs == 1 
            && (DECL_COPY_CONSTRUCTOR_P (fn) 
@@ -7247,7 +7247,7 @@ build_cxx_call (tree fn, int nargs, tree *argarray,
     /* If it is a built-in array notation function, then the return type of
      the function is the element type of the array passed in as array 
      notation (i.e. the first parameter of the function).  */
-  if (flag_cilkplus && TREE_CODE (fn) == CALL_EXPR) 
+  if (GCC_OPTION (flag_cilkplus) && TREE_CODE (fn) == CALL_EXPR) 
     {
       enum built_in_function bif = 
 	is_cilkplus_reduce_builtin (CALL_EXPR_FN (fn));
@@ -7274,13 +7274,13 @@ build_cxx_call (tree fn, int nargs, tree *argarray,
   /* Some built-in function calls will be evaluated at compile-time in
      fold ().  Set optimize to 1 when folding __builtin_constant_p inside
      a constexpr function so that fold_builtin_1 doesn't fold it to 0.  */
-  optimize_sav = optimize;
-  if (!optimize && fndecl && DECL_IS_BUILTIN_CONSTANT_P (fndecl)
+  optimize_sav = GCC_OPTION (optimize);
+  if (!GCC_OPTION (optimize) && fndecl && DECL_IS_BUILTIN_CONSTANT_P (fndecl)
       && current_function_decl
       && DECL_DECLARED_CONSTEXPR_P (current_function_decl))
-    optimize = 1;
+    GCC_OPTION (optimize) = 1;
   fn = fold_if_not_in_template (fn);
-  optimize = optimize_sav;
+  GCC_OPTION (optimize) = optimize_sav;
 
   if (VOID_TYPE_P (TREE_TYPE (fn)))
     return fn;
@@ -7765,7 +7765,7 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
 		      access_binfo, flags, &candidates, complain);
     }
   any_viable_p = false;
-  candidates = splice_viable (candidates, pedantic, &any_viable_p);
+  candidates = splice_viable (candidates, GCC_OPTION (pedantic), &any_viable_p);
 
   if (!any_viable_p)
     {
@@ -8600,7 +8600,7 @@ joust (struct z_candidate *cand1, struct z_candidate *cand2, bool warn,
       if (comp != 0)
 	{
 	  if ((complain & tf_warning)
-	      && warn_sign_promo
+	      && GCC_OPTION (warn_sign_promo)
 	      && (CONVERSION_RANK (t1) + CONVERSION_RANK (t2)
 		  == cr_std + cr_promotion)
 	      && t1->kind == ck_std
@@ -8646,7 +8646,7 @@ joust (struct z_candidate *cand1, struct z_candidate *cand2, bool warn,
      either between a constructor and a conversion op, or between two
      conversion ops.  */
   if ((complain & tf_warning)
-      && winner && warn_conversion && cand1->second_conv
+      && winner && GCC_OPTION (warn_conversion) && cand1->second_conv
       && (!DECL_CONSTRUCTOR_P (cand1->fn) || !DECL_CONSTRUCTOR_P (cand2->fn))
       && winner != compare_ics (cand1->second_conv, cand2->second_conv))
     {
@@ -8869,7 +8869,7 @@ tweak:
 
   /* Extension: If the worst conversion for one candidate is worse than the
      worst conversion for the other, take the first.  */
-  if (!pedantic && (complain & tf_warning_or_error))
+  if (!GCC_OPTION (pedantic) && (complain & tf_warning_or_error))
     {
       conversion_rank rank1 = cr_identity, rank2 = cr_identity;
       struct z_candidate *w = 0, *l = 0;
@@ -9262,7 +9262,7 @@ set_up_extended_ref_temp (tree decl, tree expr, vec<tree, va_gc> **cleanups,
     expr = get_target_expr (expr);
 
   if (TREE_CODE (decl) == FIELD_DECL
-      && extra_warnings && !TREE_NO_WARNING (decl))
+      && GCC_OPTION (extra_warnings) && !TREE_NO_WARNING (decl))
     {
       warning (OPT_Wextra, "a temporary bound to %qD only persists "
 	       "until the constructor exits", decl);
diff --git a/gcc/cp/class.c b/gcc/cp/class.c
index b46391b..5bb0caa 100644
--- a/gcc/cp/class.c
+++ b/gcc/cp/class.c
@@ -1605,7 +1605,7 @@ check_bases (tree t,
 
       /* Don't bother collecting tm attributes if transactional memory
 	 support is not enabled.  */
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	{
 	  tree tm_attr = find_tm_attribute (TYPE_ATTRIBUTES (basetype));
 	  if (tm_attr)
@@ -1860,7 +1860,7 @@ maybe_warn_about_overly_private_class (tree t)
   int has_nonprivate_method = 0;
   tree fn;
 
-  if (!warn_ctor_dtor_privacy
+  if (!GCC_OPTION (warn_ctor_dtor_privacy)
       /* If the class has friends, those entities might create and
 	 access instances, so we should not warn.  */
       || (CLASSTYPE_FRIEND_CLASSES (t)
@@ -3675,7 +3675,7 @@ check_field_decls (tree t, tree *access_decls,
 	is needed to free dynamic memory.
 
      This seems enough for practical purposes.  */
-  if (warn_ecpp
+  if (GCC_OPTION (warn_ecpp)
       && has_pointers
       && TYPE_HAS_USER_CONSTRUCTOR (t)
       && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (t)
@@ -4198,7 +4198,7 @@ layout_empty_base (record_layout_info rli, tree binfo,
   if (CLASSTYPE_USER_ALIGN (basetype))
     {
       rli->record_align = MAX (rli->record_align, CLASSTYPE_ALIGN (basetype));
-      if (warn_packed)
+      if (GCC_OPTION (warn_packed))
 	rli->unpacked_align = MAX (rli->unpacked_align, CLASSTYPE_ALIGN (basetype));
       TYPE_USER_ALIGN (rli->t) = 1;
     }
@@ -4833,7 +4833,7 @@ set_method_tm_attributes (tree t)
 
   /* Don't bother collecting tm attributes if transactional memory
      support is not enabled.  */
-  if (!flag_tm)
+  if (!GCC_OPTION (flag_tm))
     return;
 
   /* Process virtual methods first, as they inherit directly from the
@@ -5550,7 +5550,7 @@ check_bases_and_members (tree t)
   /* If the class has no user-declared constructor, but does have
      non-static const or reference data members that can never be
      initialized, issue a warning.  */
-  if (warn_uninitialized
+  if (GCC_OPTION (warn_uninitialized)
       /* Classes with user-declared constructors are presumed to
 	 initialize these members.  */
       && !TYPE_HAS_USER_CONSTRUCTOR (t)
@@ -5815,7 +5815,7 @@ layout_virtual_bases (record_layout_info rli, splay_tree offsets)
 	     cases; to deal with all the possibilities would probably
 	     require performing both layout algorithms and comparing
 	     the results which is not particularly tractable.  */
-	  if (warn_abi
+	  if (GCC_OPTION (warn_abi)
 	      && first_vbase
 	      && (tree_int_cst_lt
 		  (size_binop (CEIL_DIV_EXPR,
@@ -5931,7 +5931,7 @@ warn_about_ambiguous_bases (tree t)
     }
 
   /* Check for ambiguous virtual bases.  */
-  if (extra_warnings)
+  if (GCC_OPTION (extra_warnings))
     for (vbases = CLASSTYPE_VBASECLASSES (t), i = 0;
 	 vec_safe_iterate (vbases, i, &binfo); i++)
       {
@@ -6159,7 +6159,7 @@ layout_class_type (tree t, tree *virtuals_p)
 	  /* We must also reset the DECL_MODE of the field.  */
 	  if (abi_version_at_least (2))
 	    DECL_MODE (field) = TYPE_MODE (type);
-	  else if (warn_abi
+	  else if (GCC_OPTION (warn_abi)
 		   && DECL_MODE (field) != TYPE_MODE (type))
 	    /* Versions of G++ before G++ 3.4 did not reset the
 	       DECL_MODE.  */
@@ -6181,7 +6181,7 @@ layout_class_type (tree t, tree *virtuals_p)
       /* If a bit-field does not immediately follow another bit-field,
 	 and yet it starts in the middle of a byte, we have failed to
 	 comply with the ABI.  */
-      if (warn_abi
+      if (GCC_OPTION (warn_abi)
 	  && DECL_C_BIT_FIELD (field)
 	  /* The TREE_NO_WARNING flag gets set by Objective-C when
 	     laying out an Objective-C class.  The ObjC ABI differs
@@ -6197,7 +6197,7 @@ layout_class_type (tree t, tree *virtuals_p)
 
       /* G++ used to use DECL_FIELD_OFFSET as if it were the byte
 	 offset of the field.  */
-      if (warn_abi
+      if (GCC_OPTION (warn_abi)
 	  && !abi_version_at_least (2)
 	  && !tree_int_cst_equal (DECL_FIELD_OFFSET (field),
 				  byte_position (field))
@@ -6288,7 +6288,7 @@ layout_class_type (tree t, tree *virtuals_p)
 	{
 	  TYPE_SIZE (base_t) = bitsize_zero_node;
 	  TYPE_SIZE_UNIT (base_t) = size_zero_node;
-	  if (warn_abi && !integer_zerop (rli_size_unit_so_far (rli)))
+	  if (GCC_OPTION (warn_abi) && !integer_zerop (rli_size_unit_so_far (rli)))
 	    warning (OPT_Wabi,
 		     "layout of classes derived from empty class %qT "
 		     "may change in a future version of GCC",
@@ -6527,7 +6527,7 @@ finish_struct_1 (tree t)
 
       /* If we're warning about ABI tags, check the types of the new
 	 virtual functions.  */
-      if (warn_abi_tag)
+      if (GCC_OPTION (warn_abi_tag))
 	for (tree v = virtuals; v; v = TREE_CHAIN (v))
 	  check_abi_tags (t, TREE_VALUE (v));
     }
@@ -6597,7 +6597,7 @@ finish_struct_1 (tree t)
 
   /* This warning does not make sense for Java classes, since they
      cannot have destructors.  */
-  if (!TYPE_FOR_JAVA (t) && warn_nonvdtor && TYPE_POLYMORPHIC_P (t))
+  if (!TYPE_FOR_JAVA (t) && GCC_OPTION (warn_nonvdtor) && TYPE_POLYMORPHIC_P (t))
     {
       tree dtor;
 
@@ -6619,7 +6619,7 @@ finish_struct_1 (tree t)
 
   complete_vars (t);
 
-  if (warn_overloaded_virtual)
+  if (GCC_OPTION (warn_overloaded_virtual))
     warn_hidden (t);
 
   /* Class layout, assignment of virtual table slots, etc., is now
@@ -6629,7 +6629,7 @@ finish_struct_1 (tree t)
 
   maybe_suppress_debug_info (t);
 
-  if (flag_vtable_verify)
+  if (GCC_OPTION (flag_vtable_verify))
     vtv_save_class_info (t);
 
   dump_class_hierarchy (t);
@@ -7593,7 +7593,7 @@ resolve_address_of_overloaded_function (tree target_type,
   fn = TREE_PURPOSE (matches);
 
   if (DECL_NONSTATIC_MEMBER_FUNCTION_P (fn)
-      && !(flags & tf_ptrmem_ok) && !flag_ms_extensions)
+      && !(flags & tf_ptrmem_ok) && !GCC_OPTION (flag_ms_extensions))
     {
       static int explained;
 
@@ -7687,7 +7687,7 @@ instantiate_type (tree lhstype, tree rhs, tsubst_flags_t flags)
       tree fntype = non_reference (lhstype);
       if (same_type_p (fntype, TREE_TYPE (rhs)))
 	return rhs;
-      if (flag_ms_extensions
+      if (GCC_OPTION (flag_ms_extensions)
 	  && TYPE_PTRMEMFUNC_P (fntype)
 	  && !TYPE_PTRMEMFUNC_P (TREE_TYPE (rhs)))
 	/* Microsoft allows `A::f' to be resolved to a
@@ -7722,7 +7722,7 @@ instantiate_type (tree lhstype, tree rhs, tsubst_flags_t flags)
   gcc_assert (TREE_CODE (rhs) == ADDR_EXPR
 	      || TREE_CODE (rhs) == COMPONENT_REF
 	      || is_overloaded_fn (rhs)
-	      || (flag_ms_extensions && TREE_CODE (rhs) == FUNCTION_DECL));
+	      || (GCC_OPTION (flag_ms_extensions) && TREE_CODE (rhs) == FUNCTION_DECL));
 
   /* This should really only be used when attempting to distinguish
      what sort of a pointer to function we have.  For now, any
@@ -7997,8 +7997,8 @@ note_name_declared_in_class (tree name, tree decl)
      name, and the C++ standard says this diagnostic is not required.  So
      allow it in extern "C" blocks unless predantic is specified.
      Allow it in all cases if -ms-extensions is specified.  */
-  if ((!pedantic && current_lang_name == lang_name_c)
-      || flag_ms_extensions)
+  if ((!GCC_OPTION (pedantic) && current_lang_name == lang_name_c)
+      || GCC_OPTION (flag_ms_extensions))
     return;
   n = splay_tree_lookup (names_used, (splay_tree_key) name);
   if (n)
@@ -9418,7 +9418,7 @@ build_rtti_vtbl_entries (tree binfo, vtbl_init_data* vid)
 			BINFO_OFFSET (vid->rtti_binfo), BINFO_OFFSET (b));
 
   /* The second entry is the address of the typeinfo object.  */
-  if (flag_rtti)
+  if (GCC_OPTION (flag_rtti))
     decl = build_address (get_tinfo_decl (t));
   else
     decl = integer_zero_node;
diff --git a/gcc/cp/cp-cilkplus.c b/gcc/cp/cp-cilkplus.c
index f3a2aff..7bcc0d9 100644
--- a/gcc/cp/cp-cilkplus.c
+++ b/gcc/cp/cp-cilkplus.c
@@ -130,7 +130,7 @@ cilk_install_body_with_frame_cleanup (tree fndecl, tree orig_body, void *wd)
   append_to_statement_list (detach_expr, &body);
   cilk_outline (fndecl, &orig_body, (struct wrapper_data *) wd);
   append_to_statement_list (orig_body, &body);
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     {
       tree except_flag = set_cilk_except_flag (frame);
       tree except_data = set_cilk_except_data (frame);
diff --git a/gcc/cp/cp-gimplify.c b/gcc/cp/cp-gimplify.c
index ef4b043..4abce98 100644
--- a/gcc/cp/cp-gimplify.c
+++ b/gcc/cp/cp-gimplify.c
@@ -428,7 +428,7 @@ gimplify_expr_stmt (tree *stmt_p)
      In this case we will not want to emit the gimplified statement.
      However, we may still want to emit a warning, so we do that before
      gimplification.  */
-  if (stmt && warn_unused_value)
+  if (stmt && GCC_OPTION (warn_unused_value))
     {
       if (!TREE_SIDE_EFFECTS (stmt))
 	{
@@ -1311,7 +1311,7 @@ cp_genericize (tree fndecl)
     return;
 
   /* Expand all the array notations here.  */
-  if (flag_cilkplus 
+  if (GCC_OPTION (flag_cilkplus) 
       && contains_array_notation_expr (DECL_SAVED_TREE (fndecl)))
     DECL_SAVED_TREE (fndecl) = 
       expand_array_notation_exprs (DECL_SAVED_TREE (fndecl));
@@ -1320,7 +1320,7 @@ cp_genericize (tree fndecl)
      walk_tree's hash functionality.  */
   cp_genericize_tree (&DECL_SAVED_TREE (fndecl));
 
-  if (flag_sanitize & SANITIZE_RETURN)
+  if (GCC_OPTION (flag_sanitize) & SANITIZE_RETURN)
     cp_ubsan_maybe_instrument_return (fndecl);
 
   /* Do everything else.  */
diff --git a/gcc/cp/cvt.c b/gcc/cp/cvt.c
index e8ece0e..0088d19 100644
--- a/gcc/cp/cvt.c
+++ b/gcc/cp/cvt.c
@@ -184,7 +184,7 @@ cp_convert_to_pointer (tree type, tree expr, tsubst_flags_t complain)
 			   /*c_cast_p=*/false, complain);
   else if (TYPE_PTRMEMFUNC_P (intype))
     {
-      if (!warn_pmf2ptr)
+      if (!GCC_OPTION (warn_pmf2ptr))
 	{
 	  if (TREE_CODE (expr) == PTRMEM_CST)
 	    return cp_convert_to_pointer (type, PTRMEM_CST_MEMBER (expr),
@@ -1156,7 +1156,7 @@ convert_to_void (tree expr, impl_conv_void implicit, tsubst_flags_t complain)
                  such expressions, see build_over_call in call.c.)
                - automatic dereferencing of references, since the user cannot
                  control it. (See also warn_if_unused_value() in c-common.c.)  */
-            if (warn_unused_value
+            if (GCC_OPTION (warn_unused_value)
 		&& implicit != ICV_CAST
                 && (complain & tf_warning)
                 && !TREE_NO_WARNING (expr)
@@ -1335,7 +1335,7 @@ convert_to_void (tree expr, impl_conv_void implicit, tsubst_flags_t complain)
   if (expr != error_mark_node && !VOID_TYPE_P (TREE_TYPE (expr)))
     {
       if (implicit != ICV_CAST
-	  && warn_unused_value
+	  && GCC_OPTION (warn_unused_value)
 	  && !TREE_NO_WARNING (expr)
 	  && !processing_template_decl)
 	{
